using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc;
using SomethingWithThreadsLib.Services;
using SomethingWithThreadsLib.Model;

namespace SomethingWithThreadsApp.Pages.Threadings

{
    public class IOBasedModel : PageModel
    {
        private ISillyHotelRepository _repo;
        private const int NO_OF_HOTELS = 50;

        public IOBasedModel(ISillyHotelRepository repo)
        {
            _repo = repo;
        }


        [BindProperty]
        public int NoOfThreads { get; set; }

        public List<Hotel> Hotels { get; set; }


        public void OnGet()
        {
            NoOfThreads = 1;
            Hotels = new List<Hotel>();
        }

        public IActionResult OnPostClear()
        {
            Hotels = new List<Hotel>();
            return Page();
        }

        public IActionResult OnPostUden()
        {
            Hotels = new List<Hotel>();
            for (int i = 1; i <= NO_OF_HOTELS; i++)
            {
                Hotel hotel = _repo.GetById(i);
                Hotels.Add(hotel);
            }

            return Page();
        }

        public IActionResult OnPostMed()
        {
            Hotels = new List<Hotel>();

            // Insert your code here
            







            Hotels.Sort();
            return Page();
        }
    }
}