using SomethingWithThreadsLib.Services;
using SomethingWithThreadsLib.Model;
using SomethingWithThreadsApp.Pages;
using SomethingWithThreadsApp;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddRazorPages();

builder.Services.AddSingleton<IComputingService>(new ComputingService());
builder.Services.AddSingleton<ISillyHotelRepository>(new SillyHotelRepository());


var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error");
}
app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

app.MapRazorPages();

app.Run();
